Welcome to mirror list, hosted at ThFree Co, Russian Federation.

gitlab.com/gitlab-org/gitlab-foss.git - Unnamed repository; edit this file 'description' to name the repository.
summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
-rw-r--r--changelogs/unreleased/lint-changelog-yaml.yml5
-rwxr-xr-xscripts/lint-changelog-yaml19
-rwxr-xr-xscripts/static-analysis3
3 files changed, 26 insertions, 1 deletions
diff --git a/changelogs/unreleased/lint-changelog-yaml.yml b/changelogs/unreleased/lint-changelog-yaml.yml
new file mode 100644
index 00000000000..dcc8bf54827
--- /dev/null
+++ b/changelogs/unreleased/lint-changelog-yaml.yml
@@ -0,0 +1,5 @@
+---
+title: Detect when changelog entries are invalid
+merge_request:
+author:
+type: other
diff --git a/scripts/lint-changelog-yaml b/scripts/lint-changelog-yaml
new file mode 100755
index 00000000000..402a0c42bd3
--- /dev/null
+++ b/scripts/lint-changelog-yaml
@@ -0,0 +1,19 @@
+#!/usr/bin/env ruby
+
+require 'yaml'
+
+invalid_changelogs = Dir['changelogs/**/*.yml'].reject do |changelog|
+ begin
+ YAML.load_file(changelog)
+ rescue
+ end
+end
+
+if invalid_changelogs.any?
+ puts "Changelogs with invalid YAML found!\n"
+ puts invalid_changelogs.sort
+ exit 1
+else
+ puts "All changelogs are valid YAML.\n"
+ exit 0
+end
diff --git a/scripts/static-analysis b/scripts/static-analysis
index 295b6f132c1..aeefb2bc96f 100755
--- a/scripts/static-analysis
+++ b/scripts/static-analysis
@@ -13,7 +13,8 @@ tasks = [
%w[yarn run eslint],
%w[bundle exec rubocop --require rubocop-rspec],
%w[scripts/lint-conflicts.sh],
- %w[bundle exec rake gettext:lint]
+ %w[bundle exec rake gettext:lint],
+ %w[scripts/lint-changelog-yaml]
]
failed_tasks = tasks.reduce({}) do |failures, task|